package com.link.core.util.entry;

import com.alibaba.fastjson.JSON;
import java.util.ArrayList;
import java.util.List;
import java.util.function.Consumer;
import java.util.function.Supplier;

public class EntityBuilder {

   private final Supplier constructor;
   private final List dInjects = new ArrayList();


   private EntityBuilder(Supplier constructor) {
      this.constructor = constructor;
   }

   public static EntityBuilder builder(Supplier constructor) {
      return new EntityBuilder(constructor);
   }

   public EntityBuilder with(EntityBuilder.DInjectConsumer consumer, Object p1) {
      Consumer c = accept<invokedynamic>(consumer, p1);
      this.dInjects.add(c);
      return this;
   }

   public Object build() {
      Object instance = this.constructor.get();
      this.dInjects.forEach(accept<invokedynamic>(instance));
      return instance;
   }

   public static void main(String[] args) {
      EntityBuilder.Student student = (EntityBuilder.Student)builder(get<invokedynamic>()).with(accept<invokedynamic>(), "张三").with(accept<invokedynamic>(), Integer.valueOf(20)).build();
      System.out.println(JSON.toJSONString(student));
   }

   // $FF: synthetic method
   private static void lambda$build$1(Object instance, Consumer s) {
      s.accept(instance);
   }

   // $FF: synthetic method
   private static void lambda$with$0(EntityBuilder.DInjectConsumer consumer, Object p1, Object instance) {
      consumer.accept(instance, p1);
   }

   static class Student {

      private String name;
      private Integer age;


      public String getName() {
         return this.name;
      }

      public void setName(String name) {
         this.name = name;
      }

      public Integer getAge() {
         return this.age;
      }

      public void setAge(Integer age) {
         this.age = age;
      }
   }

   @FunctionalInterface
   public interface DInjectConsumer {

      void accept(Object var1, Object var2);
   }
}
